;;;	custom-c-mode.el - C/C++ editing mode customizations
;;;
;;;	Author:		Stefan Hundhammer <sh@suse.de>
;;;	Updated:	2005-11-07
;;;     some changes by Dennis Sieben <dsieben@suse.de>

(require 'limal-cc-mode)

;;	(load "cc-vars")
;;	(load "cc-defs")
;;	(load "cc-align")
;;	(load "cc-cmds")
;;	(load "cc-compat")
;;	(load "~/.xemacs/cc-engine")
;;	(load "cc-langs")
;;	(load "cc-menus")
;;	(load "cc-styles")
;;	(load "cc-mode")
;;(require 'cc-mode)
;;(defun my-build-tab-stop-list (width)
;;  (let ((num-tab-stops (/ 80 width))
;;      (counter 1)
;;      (ls nil))
;;  (while (<= counter num-tab-stops)
;;    (setq ls (cons (* width counter) ls))
;;    (setq counter (1+ counter)))
;;  (set (make-local-variable 'tab-stop-list) (nreverse ls))))
;;(defun my-c-mode-common-hook ()
;;    (setq tab-width 5) ;; change this to taste, this is what K&R uses :)
;;    (my-build-tab-stop-list tab-width)
;;    (setq c-basic-offset tab-width))
;;(add-hook 'c-mode-common-hook 'my-c-mode-common-hook)

(setq auto-mode-alist
  (append '(("\\.cpp"	. c++-mode)
	    ("\\.h$"	. c++-mode)
	    ("\\.c$"	. c++-mode)
	    ("\\.ycp"	. ycp-mode))
	  auto-mode-alist))

(defconst sh-c-style
  '(            (c-tab-always-indent	. t)
  (c-insert-tab-function . tab-to-tab-stop)
    (indent-tabs-mode . t)
    (c-basic-offset		. 4)
    (c-electric-pound-behavior alignleft)
    (c-offsets-alist .	(
			 (inline-open		. 0)	; '{' after functions
			 (substatement-open	. 0)	; '{' after if, else, while, ...
			 (statement-block-intro	. +)	; first line after if(), ...
			 (case-label		. +)	; 'case XY:'
			 (statement-case-intro	. +)	; first line after 'case XY:'
			 (statement-case-open	. +)	; '{' after 'case XY:' (???)
			 (statement-cont	. +)	; statement continuation line
			 (label			. -1000) ; goto label
			 (arglist-intro		. c-lineup-arglist-intro-after-paren)	; Indenting of
			 ; the arglist of functions
			 (arglist-cont-nonempty	. c-lineup-arglist-intro-after-paren)	; Ebenso
			 (arglist-close		. c-lineup-arglist-close-under-paren)	; Ebenso
			 )))
  "SH C/C++ Programming Style")

(defconst c-protection-key 
  (concat
   "\\<\\("
   "\\(public\\|protected\\|private\\|signal\\|slot\\)"
   "\\( *slot\\)"
   "\\)\\>"
   ))


(c-initialize-builtin-style)
(c-add-style "SH-C/C++" sh-c-style t)


(defun c-mode-usr-init ()
  "User defined startup function for C program editing mode."
  (c-set-style "SH-C/C++")
  (local-set-key	"\C-M"		'newline-and-indent)
  ;(local-set-key	"\177"		'backward-delete-char)
  (local-set-key	"\M-q"		'fill-paragraph)
  (local-set-key	"\C-\M-q"	'fill-paragraph)
  (setq paragraph-separate	"^$\\|^\\|^[^ 	]"))


(defun insert-c-block ()	; no args
  "Insert a C/C++ block: A pair of braces and an empty line to type into"
  (interactive)			; user can invoke cmd
  (beginning-of-line)
  (insert-char ?{ 1)
  (beginning-of-line)
  (c-indent-command)
  (end-of-line)
  (newline 1)
  (insert-char ?} 1)
  (beginning-of-line)
  (c-indent-command)
  (previous-line 1)
  (end-of-line)
  (newline-and-indent))


(setq		c-mode-common-hook	'c-mode-usr-init)
(setq-default	c-site-default-style	"SH-C/C++")
(setq-default	c-default-style		"SH-C/C++")



;;; <EOF>
