#include <fstream>
#include <iostream>
#include <limal/XXpkgXX/XXPkgXX.hpp>

#include <blocxx/String.hpp>
#include <limal/Logger.hpp>

using namespace blocxx;
using namespace limal;
using namespace std;

int main( int argc, char **argv )
{
	if ( argc != 2 )
	{
		cerr << "Usage: test_multi <filepath>" << endl;
		exit( 1 );
	}

	// let's allow the lib to log on stderr:
	limal::Logger::setDefaultLogger(
		limal::Logger::createCerrLogger(
			"test_multi",
			blocxx::StringArray(1, "*"),
			blocxx::StringArray(1, "*"),
			"%-5p %c - %m"
		)
	);

	String file = argv[ 1 ];

	cout << "START"  << endl;
	cout << "file: " << file << endl;

	ifstream in( file.c_str() );
	if ( in.fail() )
	{
		cerr << "Unable to load '" << file << "'" << endl;
		exit( 2 );
	}
  
	while( in )
	{
		String     line = String::getLine( in );
		XXpKgXX::XXPkgXX xx;

		cout << "setBuffer(\"" << line << "\")" << endl;
		xx.setBuffer( line );
		cout << "getBuffer return:" << endl;
		cout <<   xx.getBuffer() << endl;
	}

	cout << "==================================" << endl;

	return 0;
}

